<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		banners
 */

class Block_main_topsites
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		$info=array();
		$info['author']='Chris Graham';
		$info['organisation']='ocProducts';
		$info['hacked_by']=NULL;
		$info['hack_version']=NULL;
		$info['version']=2;
		$info['locked']=false;
		$info['parameters']=array('param');
		return $info;
	}

	/**
	 * Standard modular cache function.
	 *
	 * @return ?array	Map of cache details (cache_on and ttl) (NULL: module is disabled).
	 */
	function cacheing_environment()
	{
		$info=array();
		$info['cache_on']='array(array_key_exists(\'param\',$map)?$map[\'param\']:\'\')';
		$info['ttl']=60*24;
		return $info;
	}

	/**
	 * Standard modular run function.
	 *
	 * @param  array		A map of parameters.
	 * @return tempcode	The result of execution.
	 */
	function run($map)
	{
		if (!array_key_exists('param',$map)) $map['param']='';

		require_code('banners');
		require_lang('banners');

		$b_type=$map['param'];
		$myquery='SELECT * FROM '.get_table_prefix().'banners WHERE validated=1 AND '.db_string_equal_to('b_type',$b_type).' AND (expiry_date IS NULL OR expiry_date>'.strval(time()).') ORDER BY hits_from+hits_to DESC';
		$_banners=$GLOBALS['SITE_DB']->query($myquery,200);
		$assemble=new ocp_tempcode();

		$banners=array();

		foreach ($_banners as $banner)
		{
			$description=get_translated_tempcode($banner['caption']);

			$bd=show_banner($banner['name'],$banner['b_title_text'],$description,$banner['b_direct_code'],$banner['img_url'],'',$banner['site_url'],$banner['b_type'],$banner['submitter']);

			$banners[]=array(
				'BANNER'=>$bd,
				'NAME'=>$banner['name'],
				'URL'=>$banner['site_url'],
				'DESCRIPTION'=>$description,
				'HITSFROM'=>strval($banner['hits_from']),
				'HITSTO'=>strval($banner['hits_to']),
				'VIEWSFROM'=>strval($banner['views_from']),
				'VIEWSTO'=>strval($banner['views_to']),
				'ADDDATE'=>strval($banner['add_date']),
				'SUBMITTER'=>strval($banner['submitter']),
			);
		}

		if ((has_actual_page_access(NULL,'cms_banners',NULL,NULL)) && (has_submit_permission('mid',get_member(),get_ip_address(),'cms_banners')))
		{
			$submit_url=build_url(array('page'=>'cms_banners','type'=>'ad','redirect'=>SELF_REDIRECT),get_module_zone('cms_banners'));
		} else $submit_url=new ocp_tempcode();

		return do_template('BLOCK_MAIN_TOPSITES',array('TYPE'=>$map['param'],'BANNERS'=>$banners,'SUBMIT_URL'=>$submit_url));
	}

}


