<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		backup
 */

class Hook_checklist_backup
{

	/**
	 * Standard modular run function.
	 *
	 * @return array		An array of tuples: The task row to show, the number of seconds until it is due (or NULL if not on a timer), the number of things to sort out (or NULL if not on a queue), The name of the config option that controls the schedule (or NULL if no option).
	 */
	function run()
	{
		if (!addon_installed('backup')) return array();

		if (get_option('backup_time',true)=='') return array();
		$limit_hours=intval(get_option('backup_time',true));

		require_lang('backups');

		$date=intval(get_value('last_backup'));

		$seconds_ago=mixed();
		if ($date!=0)
		{
			$seconds_ago=time()-$date;
			$status=(intval($seconds_ago)>$limit_hours*60*60)?0:1;
		} else
		{
			$status=0;
		}

		$_status=($status==0)?do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM_STATUS_0'):do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM_STATUS_1');

		$config_row=$GLOBALS['SITE_DB']->query_select('config',array('the_page','section'),array('the_name'=>'backup_time'),'',1);
		if (array_key_exists(0,$config_row))
		{
			$_config_url=build_url(array('page'=>'admin_config','type'=>'category','id'=>$config_row[0]['the_page']),get_module_zone('admin_config'));
			$config_url=$_config_url->evaluate();
			$config_url.='#group_'.$config_row[0]['section'];
		} else $config_url=NULL;

		$url=build_url(array('page'=>'admin_backup','type'=>'misc'),'adminzone');
		list($info,$seconds_due_in)=staff_checklist_time_ago_and_due($seconds_ago,$limit_hours);
		$tpl=do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM',array('_GUID'=>'432685ec6c9f7548ce8b488b6ce00030','CONFIG_URL'=>$config_url,'URL'=>$url,'STATUS'=>$_status,'TASK'=>do_lang_tempcode('BACKUP'),'INFO'=>$info));
		return array(array($tpl,$seconds_due_in,NULL,'backup_time'));
	}

}


