<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		news
 */

class Hook_awards_news
{

	/**
	 * Standard modular info function for award hooks. Provides information to allow task reporting, randomisation, and add-screen linking, to function.
	 *
	 * @return ?array	Map of award content-type info (NULL: disabled).
	 */
	function info()
	{
		$info=array();
		$info['connection']=$GLOBALS['SITE_DB'];
		$info['table']='news';
		$info['date_field']='date_and_time';
		$info['id_field']='id';
		$info['add_url']=(has_submit_permission('mid',get_member(),get_ip_address(),'cms_news'))?build_url(array('page'=>'cms_news','type'=>'ad'),get_module_zone('cms_news')):new ocp_tempcode();
		$info['category_field']='news_category';
		$info['category_type']='news';
		$info['parent_spec__table_name']='news_categories';
		$info['parent_spec__parent_name']=NULL;
		$info['parent_spec__field_name']='id';
		$info['parent_field_name']='news_category';
		$info['submitter_field']='submitter';
		$info['id_is_string']=false;
		require_lang('news');
		$info['title']=do_lang_tempcode('NEWS');
		$info['validated_field']='validated';
		$info['category_is_string']=false;
		$info['archive_url']=build_url(array('page'=>'news'),get_module_zone('news'));
		$info['cms_page']='cms_news';
		$info['views_field']='news_views';
		$info['supports_custom_fields']=true;

		return $info;
	}

	/**
	 * Standard modular run function for award hooks. Renders a content box for an award/randomisation.
	 *
	 * @param  array		The database row for the content
	 * @param  ID_TEXT	The zone to display in
	 * @return tempcode	Results
	 */
	function run($row,$zone)
	{
		require_code('news');
		return render_news_box($row,$zone);
	}

}


